#display.py
#Copyright (C) 2006 Evil Mr Henry
#This file is part of The Monster's Tower.

#The Monster's Tower is free software; you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation; either version 2 of the License, or
#(at your option) any later version.

#The Monster's Tower is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.

#You should have received a copy of the GNU General Public License
#along with The Monster's Tower; if not, write to the Free Software
#Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


#This file handles all the opengl stuff.

from OpenGL import GL
from OpenGL import GLU
import pygame
from os import listdir

import level
import math

#Honestly, I just pulled this off one of the nehe tutorials. I think some of
#it is unneeded.
def setup_opengl((width, height)):
    GL.glDisable (GL.GL_LIGHTING)
    GL.glDisable(GL.GL_NORMALIZE)
    GL.glDisable (GL.GL_COLOR_MATERIAL)
    #GL.glLightModelfv(GL.GL_LIGHT_MODEL_AMBIENT, (0.8, 0.8, 0.8, 1.0))
    #GL.glLightModelfv(GL.GL_LIGHT_MODEL_AMBIENT, (0, 0, 0, 1.0))
    #GL.glShadeModel(GL.GL_SMOOTH);
    GL.glEnable(GL.GL_TEXTURE_2D)
    if height==0:
        height=1.0
    GL.glViewport(0, 0, width, height)
    GL.glMatrixMode(GL.GL_PROJECTION)
    GL.glDepthFunc(GL.GL_LESS)
    GL.glEnable(GL.GL_DEPTH_TEST)
    GL.glLoadIdentity()
    GLU.gluPerspective(45, float(width)/height, 0.1, 100.0)
    GL.glMatrixMode(GL.GL_MODELVIEW)
    GL.glLoadIdentity()


floor_squares = []
wall_n_squares = []
wall_s_squares = []
wall_e_squares = []
wall_w_squares = []
ceiling_squares = []

global lighting_name_array
lighting_name_array = []

def draw_tile(sq, height):
    GL.glBegin(GL.GL_POLYGON)
    GL.glTexCoord2f(0.0, 0.0); GL.glVertex3f(sq[0], -sq[1], height)
    GL.glTexCoord2f(1.0, 0.0); GL.glVertex3f(sq[0]+1, -sq[1], height)
    GL.glTexCoord2f(1.0, -1.0); GL.glVertex3f(sq[0]+1, -sq[1]-1, height)
    GL.glTexCoord2f(0.0, -1.0); GL.glVertex3f(sq[0], -sq[1]-1, height)
    GL.glEnd()

global polycount
polycount = 0

def draw_frame(loc, zoom, lookdir = 0):
    global polycount
    polycount = 0
    GL.glLoadIdentity()
    GL.glTranslatef(-loc[0]/10, loc[1]/10, -zoom)
    GL.glClear( GL.GL_COLOR_BUFFER_BIT | GL.GL_DEPTH_BUFFER_BIT )

    #draw floor squares
    GL.glBindTexture(GL.GL_TEXTURE_2D, 3)
    for sq in floor_squares:
        polycount+=1
        draw_tile(sq, 1.0)
    #draw ceiling squares
    GL.glBindTexture(GL.GL_TEXTURE_2D, 1)
    for sq in ceiling_squares:
        polycount+=1
        draw_tile(sq, 4.0)

    GL.glBindTexture(GL.GL_TEXTURE_2D, 2)
    for sq in wall_n_squares:
        if sq[1]*10 < loc[1]: continue
        for i in range(4):
            polycount+=1
            GL.glBegin(GL.GL_POLYGON)
            GL.glTexCoord2f(0.0, 0.0); GL.glVertex3f(sq[0], -sq[1], i)
            GL.glTexCoord2f(1.0, 0.0); GL.glVertex3f(sq[0]+1, -sq[1], i)
            GL.glTexCoord2f(1.0, 1.0); GL.glVertex3f(sq[0]+1, -sq[1], i+1)
            GL.glTexCoord2f(0.0, 1.0); GL.glVertex3f(sq[0], -sq[1], i+1)
            GL.glEnd()
    for sq in wall_s_squares:
        if sq[1]*10 > loc[1]: continue
        for i in range(4):
            polycount+=1
            GL.glBegin(GL.GL_POLYGON)
            GL.glTexCoord2f(0.0, 0.0); GL.glVertex3f(sq[0], -sq[1]-1, i)
            GL.glTexCoord2f(1.0, 0.0); GL.glVertex3f(sq[0]+1, -sq[1]-1, i)
            GL.glTexCoord2f(1.0, 1.0); GL.glVertex3f(sq[0]+1, -sq[1]-1, i+1)
            GL.glTexCoord2f(0.0, 1.0); GL.glVertex3f(sq[0], -sq[1]-1, i+1)
            GL.glEnd()
    for sq in wall_e_squares:
        if sq[0]*10 > loc[0]: continue
        for i in range(4):
            polycount+=1
            GL.glBegin(GL.GL_POLYGON)
            GL.glTexCoord2f(0.0, 0.0); GL.glVertex3f(sq[0]+1, -sq[1], i)
            GL.glTexCoord2f(1.0, 0.0); GL.glVertex3f(sq[0]+1, -sq[1]-1, i)
            GL.glTexCoord2f(1.0, 1.0); GL.glVertex3f(sq[0]+1, -sq[1]-1, i+1)
            GL.glTexCoord2f(0.0, 1.0); GL.glVertex3f(sq[0]+1, -sq[1], i+1)
            GL.glEnd()
    for sq in wall_w_squares:
        if sq[0]*10 < loc[0]: continue
        for i in range(4):
            polycount+=1
            GL.glBegin(GL.GL_POLYGON)
            GL.glTexCoord2f(0.0, 0.0); GL.glVertex3f(sq[0], -sq[1], i)
            GL.glTexCoord2f(1.0, 0.0); GL.glVertex3f(sq[0], -sq[1]-1, i)
            GL.glTexCoord2f(1.0, 1.0); GL.glVertex3f(sq[0], -sq[1]-1, i+1)
            GL.glTexCoord2f(0.0, 1.0); GL.glVertex3f(sq[0], -sq[1], i+1)
            GL.glEnd()

    #player
    polycount+=1
    GL.glBegin(GL.GL_POLYGON)
    GL.glTexCoord2f(0.0, 0.0); GL.glVertex3f(loc[0]/10-0.1, -loc[1]/10-0.1, 1.001)
    GL.glTexCoord2f(1.0, 0.0); GL.glVertex3f(loc[0]/10+0.1, -loc[1]/10-0.1, 1.001)
    GL.glTexCoord2f(1.0, 1.0); GL.glVertex3f(loc[0]/10+0.1, -loc[1]/10+0.1, 1.001)
    GL.glTexCoord2f(0.0, 1.0); GL.glVertex3f(loc[0]/10-0.1, -loc[1]/10+0.1, 1.001)
    GL.glEnd()

    #enemies
    GL.glBindTexture(GL.GL_TEXTURE_2D, 1)
    #GL.glDisable (GL.GL_LIGHTING)
    i = 0
    for enemy in level.maps[0].enemy_list:
        polycount+=1
        GL.glBegin(GL.GL_POLYGON)
        GL.glTexCoord2f(0.0, 0.0); GL.glVertex3f(enemy.loc[0]/10-0.05, -enemy.loc[1]/10-0.1, 1.001)
        GL.glTexCoord2f(1.0, 0.0); GL.glVertex3f(enemy.loc[0]/10+0.05, -enemy.loc[1]/10-0.1, 1.001)
        GL.glTexCoord2f(1.0, 1.0); GL.glVertex3f(enemy.loc[0]/10+0.05, -enemy.loc[1]/10+0.1, 1.001)
        GL.glTexCoord2f(0.0, 1.0); GL.glVertex3f(enemy.loc[0]/10-0.05, -enemy.loc[1]/10+0.1, 1.001)
        GL.glEnd()

    #tmptm1 = pygame.time.get_ticks()
    GL.glBindTexture(GL.GL_TEXTURE_2D, 0)
    clipping_qual = 20
    num_beams = 20
    beam_width = level.maps[0].enemy_list[0].sightwidth*(6.283185)/(20.0*360.0)
    for enemy in level.maps[0].enemy_list:
        for i in range(-num_beams/2, num_beams):
            ray_length = enemy.sightrange /10
            for j in range(0, clipping_qual):
                if (level.maps[0].grid[int(enemy.loc[1]/10
                -math.sin(enemy.sightdir+i*beam_width
                -beam_width/2.0)*ray_length*j/clipping_qual)]
                [int(enemy.loc[0]/10+math.cos(enemy.sightdir+
                i*beam_width-beam_width/2.0)*ray_length*j/clipping_qual)]
                == "0"):
                    ray_length = (ray_length * (j+1) * 1.0) / clipping_qual
                    break
            polycount+=1
            draw_ray(enemy.loc, enemy.sightdir+i*beam_width-beam_width/2.0,
                    beam_width, ray_length)

    #print "enemy2", pygame.time.get_ticks() - tmptm1
    return polycount

#start_pos should take player and monster locs with no conversion,
#ray_dir is in radians from straight up,
#ray width is also in radians.
#ray length is measured from the ray start along a side, and is in tiles.
def draw_ray(start_pos, ray_dir, ray_width, ray_length):
    ray_width = ray_width / 2.0
    GL.glBegin(GL.GL_POLYGON)

    GL.glTexCoord2f((start_pos[0]%10)/10, -(start_pos[1]%10)/10);
    GL.glVertex3f(start_pos[0]/10, -start_pos[1]/10, 1.001)

    GL.glTexCoord2f((start_pos[0]%10)/10 +
    math.cos(ray_dir-ray_width)*ray_length,
    -((start_pos[1]%10)/10-math.sin(ray_dir-ray_width)*ray_length));
    GL.glVertex3f(start_pos[0]/10+math.cos(ray_dir-ray_width)*ray_length,
    -start_pos[1]/10+math.sin(ray_dir-ray_width)*ray_length, 1.001)

    GL.glTexCoord2f((start_pos[0]%10)/10 +
    math.cos(ray_dir+ray_width)*ray_length,
    -((start_pos[1]%10)/10-math.sin(ray_dir+ray_width)*ray_length));
    GL.glVertex3f(start_pos[0]/10+math.cos(ray_dir+ray_width)*ray_length,
    -start_pos[1]/10+math.sin(ray_dir+ray_width)*ray_length, 1.001)
    GL.glEnd()


def load_level(index):
    global lighting_name_array
    lighting_name_array = [GL.GL_LIGHT1, GL.GL_LIGHT2, GL.GL_LIGHT3,
    GL.GL_LIGHT4, GL.GL_LIGHT5, GL.GL_LIGHT6, GL.GL_LIGHT7]
    global floor_squares; global wall_n_squares; global wall_s_squares
    global wall_e_squares; global wall_w_squares; global ceiling_squares
    floor_squares = []; wall_n_squares = []; wall_s_squares = []
    wall_e_squares = []; wall_w_squares = []; ceiling_squares = []

    load_pixs((level.maps[index].floor_pic, level.maps[index].ceil_pic,
        level.maps[index].wall_pic,
        level.maps[index].floor_pic[:-4]+"-dark.png"))



    for i in range(len(level.maps[index].grid)):
        for j in range(len(level.maps[index].grid[i])):
            if level.maps[index].grid[i][j] == '1':
                floor_squares.append((j, i))
            elif level.maps[index].grid[i][j] == '0':
                ceiling_squares.append((j, i))

                if i != 0:
                    if level.maps[index].grid[i-1][j] == '1':
                        wall_n_squares.append((j, i))

                if i != level.maps[index].size[1]-1:
                    if level.maps[index].grid[i+1][j] == '1':
                        wall_s_squares.append((j, i))

                if j != 0:
                    if level.maps[index].grid[i][j-1] == '1':
                        wall_w_squares.append((j, i))
                if j != level.maps[index].size[0]-1:
                    if level.maps[index].grid[i][j+1] == '1':
                        wall_e_squares.append((j, i))

pixs = []
pixs2 = []

#Some of this is from the 6th nehe tutorial. Seems a bit "unpythony" to me...
def load_pixs(pic_list):
    global pixs; global pixs2
    pixs = []; pixs2 = []

    for i in range(len(pic_list)):
        pixs2.append(pygame.image.load("../images/"+pic_list[i]).convert_alpha())
        pixs.append(pygame.image.tostring(pixs2[-1], "RGBX", 1))
        GL.glBindTexture(GL.GL_TEXTURE_2D, i)
        GL.glTexImage2D(GL.GL_TEXTURE_2D, 0, GL.GL_RGBA, pixs2[i].get_width(),
        pixs2[i].get_height(), 0, GL.GL_RGBA, GL.GL_UNSIGNED_BYTE, pixs[i])
        GL.glTexParameterf(GL.GL_TEXTURE_2D, GL.GL_TEXTURE_MAG_FILTER,
            GL.GL_NEAREST)
        GL.glTexParameterf(GL.GL_TEXTURE_2D, GL.GL_TEXTURE_MIN_FILTER,
            GL.GL_NEAREST_MIPMAP_LINEAR)
        GLU.gluBuild2DMipmaps(GL.GL_TEXTURE_2D, 3, pixs2[i].get_width(),
            pixs2[i].get_height(), GL.GL_RGBA, GL.GL_UNSIGNED_BYTE, pixs[i])


