#map.py
#Copyright (C) 2006 Evil Mr Henry
#This file is part of The Monster's Tower.

#The Monster's Tower is free software; you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation; either version 2 of the License, or
#(at your option) any later version.

#The Monster's Tower is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.

#You should have received a copy of the GNU General Public License
#along with The Monster's Tower; if not, write to the Free Software
#Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

from os import listdir
import enemy

#map class
class map_class:
    def __init__(self, name):
        self.name = name

        self.grid = []

        filename = "../maps/"+self.name
        file = open(filename)

        temp = file.readline().strip().split(" ", 1)
        self.startpos = (int(temp[0].strip()), int(temp[1].strip()))

        i = 0
        temp = file.readline().strip().split(" ", 1)
        self.size = (int(temp[0].strip()), int(temp[1].strip()))

        #textures
        self.floor_pic = file.readline().strip()
        self.ceil_pic = file.readline().strip()
        self.wall_pic = file.readline().strip()

        #enemies
        temp = file.readline().strip()
        temp = temp.split()
        if len(temp) % 2 != 0:
            print "error in enemy list"
            return

        self.enemy_list = []
        for i in range(len(temp) / 2):
            self.enemy_list.append((int(temp[i*2]), int(temp[i*2+1])))

        self.enemyprop = file.readline().strip()
        self.enemyprop = self.enemyprop.split()

        for i in range(len(self.enemyprop)):
            self.enemyprop[i] = int(self.enemyprop[i])

        for i in range(len(self.enemy_list)):
            self.enemy_list[i] = enemy.enemy_class(self.enemy_list[i],
            self.enemyprop[0], self.enemyprop[1], self.enemyprop[2],
            self.enemyprop[3])

        #map
        for i in range(self.size[1]):
            self.grid.append([])
            temp = file.readline().strip()
            for j in range(self.size[0]):
                self.grid[-1].append(temp[j])
        file.close()


maps = []

temp_list = listdir("../maps")
temp_list.sort()

for name in temp_list:
    maps.append(map_class(name))


